#include<iostream>

using namespace std;

struct OpsegPromene{
    int L;
    int R;
};

int main(void)
{
    int N, C, Q;
    cin>>N>>C>>Q;

    string S;
    cin>>S;

    OpsegPromene niz[Q];

    for(int i=0; i<Q; ++i)
        cin>>niz[i].L>>niz[i].R;

    if(N<=C){

        for(int i=0; i<Q; ++i){

            for(int j=niz[i].L - 1 ; j <= niz[i].R-1 ; ++j ){
                if(S[j] == '1')
                    S[j]='0';
                else
                    S[j]='1';
            }

            int brojac=0;

            for(int j=0; j<N; ++j)
                if(S[j]=='1')
                    brojac++;

            cout<<brojac<<endl;
        }

    }


    return 0;

}